<template>
  <div class="page-folder">
    <Breadcrumb :breadcrumb="[{ name: 'PC', url: '/pc' }]" />
    <section class="folder-show clearfix">
      <h1 class="title_cate">
        <span>PC</span>
      </h1>
      <div class="flex mb56">
        <ProductSidebarFilter
          page="pc"
          :brands="brands"
          :list-filters="listFilters"
          :product_filters="product_filters"
          :option_filters="option_filters"
          :clear-filters="() => clearFilters()"
          :meta="products.meta"
        />
        <ProductList
          :products="products.data"
          :links="products.links"
          :meta="products.meta"
          :get-products="(page) => getProducts(page)"
        />
      </div>
    </section>
  </div>
</template>

<script>
export default {
  name: 'PcFolder',
  components: {
    Breadcrumb: () => import('~/components/Breadcrumb'),
    ProductSidebarFilter: () =>
      import('~/components/Products/Category/ProductSidebarFilter'),
    ProductList: () => import('~/components/Products/Category/ProductList'),
  },
  async asyncData({ params, $axios, query }) {
    const metaseo = await $axios.$get('/category/seo/pc')
    const brands = await $axios.$get('/catalogue/brands/pc')
    const listFilters = await $axios.$get('/catalogue/filters/list_pc')
    const products = await $axios.$post(
      '/catalogue/products/filter_pc?page=1',
      {
        product_filters: {
          brands: [],
          sub_brands: [],
        },
        option_filters: {
          type: [],
          status: [],
          price_range: [],
          cpu_name: [],
          ram: [],
          storage: [],
          display_size: [],
          display_type: [],
          display_res: [],
          gpu_onboard: [],
          gpu_vram: [],
          weight: [],
        },
      }
    )

    return {
      brands: brands.data,
      listFilters,
      products,
      metaseo: metaseo.data,
    }
  },
  data() {
    return {
      product_filters: {
        brands: [],
        sub_brands: [],
      },
      option_filters: {
        type: [],
        status: [],
        price_range: [],
        cpu_name: [],
        ram: [],
        storage: [],
        display_size: [],
        display_type: [],
        display_res: [],
        gpu_onboard: [],
        gpu_vram: [],
        weight: [],
      },
    }
  },
  watch: {
    product_filters: {
      handler(val) {
        this.getProducts(1)
      },
      deep: true,
    },
    option_filters: {
      handler(val) {
        this.getProducts(1)
      },
      deep: true,
    },
  },
  mounted() {
    this.queryFilter()
  },
  methods: {
    queryFilter() {
      const pr = this.$route.query.pr
      const dm = this.$route.query.dm
      if (pr) {
        this.option_filters.price_range = [Number(pr)]
      } else {
      }
      if (dm) {
        this.option_filters.dema = [Number(dm)]
      } else {
      }
    },
    async getProducts(page) {
      const products = await this.$axios.$post(
        '/catalogue/products/filter_pc?page=' + page,
        {
          product_filters: this.product_filters,
          option_filters: this.option_filters,
        }
      )
      this.products = products
    },
    clearFilters() {
      this.product_filters = {
        brands: [],
        sub_brands: [],
      }
      this.option_filters = {
        type: [],
        status: [],
        price_range: [],
        cpu_name: [],
        ram: [],
        storage: [],
        display_size: [],
        display_type: [],
        display_res: [],
        gpu_onboard: [],
        gpu_vram: [],
        weight: [],
      }
    },
  },
  head() {
    return {
      title: this.metaseo.title,
      meta: [
        {
          hid: 'description',
          name: 'description',
          content: this.metaseo.description,
        },
        { name: 'description', content: this.metaseo.description },
        {
          name: 'keywords',
          content: this.metaseo.keywords ? this.metaseo.keywords.slice() : '',
        },
      ],
    }
  },
}
</script>
